<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../../common/meta';
import { NextStep, SlpBreadcrumb } from '../../components/common/index.vue';

import { CONTENT_TYPES } from '../../common/content-types';
import BrowseCaseStudies from '../../components/customers/browse-case-studies.vue';
import { getClient } from '~/plugins/contentful.js';

export default Vue.extend({
  components: {
    NextStep,
    SlpBreadcrumb,
    BrowseCaseStudies,
  },
  nuxtI18n: false,

  async asyncData() {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': '/customers/all',
      });

      const data = response.items[0].fields;

      const metadata = {
        title: data.seoMetadata[0].fields.ogTitle,
        ogTitle: data.seoMetadata[0].fields.ogTitle,
        description: data.seoMetadata[0].fields.ogDescription,
        ogDescription: data.seoMetadata[0].fields.ogDescription,
      };

      const caseStudiesResponse = await getClient().getEntries({
        content_type: 'caseStudy',
        'fields.filterCompanySize[exists]': true,
        'fields.filterIndustry[exists]': true,
        'fields.filterRegion[exists]': true,
        order: '-fields.date',
      });

      const caseStudiesList = caseStudiesResponse.items;

      return { data, caseStudiesList, metadata };
    } catch (error) {
      return {};
    }
  },
  data() {
    return {
      UrlQuery: {},
    };
  },
  head() {
    return getPageMetadata((this as any).metadata, this.$route.path);
  },
  watch: {
    UrlQuery() {
      this.UrlQuery = this.$route.query;
    },
  },
  created() {
    this.UrlQuery = this.$route.query;
  },
});
</script>

<template>
  <div>
    <SlpContainer class="slp-my-lg-32 slp-mt-8 slp-mb-24">
      <SlpRow>
        <SlpBreadcrumb :crumbs="data.schema.crumbs" />
      </SlpRow>
      <SlpRow
        class="slp-mt-0 slp-mt-lg-64"
        :class="data.schema.header ? '' : 'slp-mb-8'"
      >
        <SlpTypography class="slp-mt-24" variant="heading2-bold">
          {{ data.schema.header }}
        </SlpTypography>
      </SlpRow>
    </SlpContainer>
    <client-only>
      <BrowseCaseStudies
        :case-studies-list="caseStudiesList"
        :data="data.schema.browse_case_studies"
        :url-query="UrlQuery"
      />
    </client-only>

    <NextStep :variant="data.pageContent[0].fields.variant" />
  </div>
</template>

<style lang="scss" scoped>
.header {
  &__button {
    padding-left: 0;
  }
}
</style>
